<?php
$settings = [
    'cache' => [
        'value' => [
            'sid' => $_SERVER['DOCUMENT_ROOT'] . '#01',
            'type' => 'memcache',
            'memcache' => [
                'host' => '127.0.0.1',
                'port' => '11211',
            ],
        ],
        'readonly' => false,
    ],
    'session' => [
        'value' => [
            'handlers' => [
                'general' => [
                    'type' => 'memcache',
                    'host' => '127.0.0.1',
                    'port' => '11211',
                    'keyPrefix' => $_SERVER['DOCUMENT_ROOT'] . '#02',
                ],
            ],
        ],
        'readonly' => false,
    ],
    'exception_handling' => [
        'value' => [
            'debug' => false,
            'handled_errors_types' => E_ALL & ~E_USER_DEPRECATED & ~E_DEPRECATED & ~E_STRICT & ~E_USER_NOTICE & ~E_USER_WARNING & ~E_COMPILE_WARNING & ~E_CORE_WARNING & ~E_NOTICE & ~E_WARNING,
            'exception_errors_types' => E_ALL & ~E_USER_DEPRECATED & ~E_DEPRECATED & ~E_STRICT & ~E_USER_NOTICE & ~E_USER_WARNING & ~E_COMPILE_WARNING & ~E_CORE_WARNING & ~E_NOTICE & ~E_WARNING,
            'ignore_silence' => false,
            'assertion_throws_exception' => true,
            'assertion_error_type' => E_USER_ERROR,
            'log' => [
                'settings' => [
                    'file' => realpath(__DIR__ . '/../../logs/bitrix.log'),
                    'log_size' => 20000000,
                ],
            ],
        ],
        'readonly' => false,
    ],
    'composer' => [
        'value' => ['config_path' => realpath(__DIR__ . '/../../composer.json')],
    ],
];

$mainSettings = include(".settings.php");

if (isset($mainSettings['session'])) {
    $settings['session'] = $mainSettings['session'];
}

if (getenv('RUN_MODE', true) === 'staging') {
    $settings = array_merge($settings, [
        'analytics_counter' => [
            'value' => [
                'enabled' => false
            ],
            'readonly' => false,
        ],
    ]);
}

if (getenv('RUN_MODE', true) === 'development') {
    $settings = array_merge($settings, [
        'cache' => [
            'value' => [
                'type' => 'memcache',
                'memcache' => [
                    'host' => 'memcached',
                    'port' => '11211',
                ],
                'sid' => $_SERVER['DOCUMENT_ROOT'] . '#01',
            ],
        ],
        'session' => [
            'value' => [
                'handlers' => [
                    'general' => [
                        'type' => 'memcache',
                        'host' => 'memcached',
                        'port' => '11211',
                        'keyPrefix' => $_SERVER['DOCUMENT_ROOT'] . '#02',
                    ],
                ],
            ],
            'readonly' => false,
        ],
        'exception_handling' => [
            'value' => [
                'debug' => true,
                'handled_errors_types' => E_ALL & ~E_NOTICE & ~E_DEPRECATED,
                'exception_errors_types' => E_ALL & ~E_NOTICE & ~E_DEPRECATED,
                'ignore_silence' => false,
                'assertion_throws_exception' => true,
                'assertion_error_type' => E_ALL,
                'log' => null,
            ],
            'readonly' => false,
        ],
        'connections' => [
            'value' => [
                'default' => [
                    'className' => '\\Bitrix\\Main\\DB\\MysqliConnection',
                    'host' => 'db',
                    'port' => 3306,
                    'database' => 'cetera',
                    'login' => 'cetera',
                    'password' => 'cetera',
                    'options' => 2,
                ],
            ],
        ],
        'https_request' => [
            'value' => false,
        ],
        'analytics_counter' => [
            'value' => [
                'enabled' => false
            ],
            'readonly' => false,
        ],
    ]);
} elseif (getenv('RUN_MODE', true) === 'load_testing') {
    $settings = array_merge($settings, [
        'connections' => [
            'value' => [
                'default' => [
                    'className' => '\\Bitrix\\Main\\DB\\MysqliConnection',
                    'host' => 'localhost',
                    'database' => 'load',
                    'login' => 'load',
                    'password' => '0kjNRU2rTaFHQMb1bFEB',
                    'options' => 2,
                ],
            ],
        ]
    ]);
}

return $settings;
